/*******************************************************************************
 Project   : AT89S52 base RPM counter
 Developer : Dilshan R Jayakody (jayakody2000lk@live.com)
 Project ID: N0010D07302009
 Rev. Date : Thursday, July 30, 2009
 Web       : http://jayakody2000lk.blogspot.com
*******************************************************************************/

unsigned int rpm_, count_pos, tk_counter;

void output_digit(char digit) {
  switch(digit) {
    case 0: P0 = 0x81; break;
    case 1: P0 = 0xCF; break;
    case 2: P0 = 0x92; break;
    case 3: P0 = 0x86; break;
    case 4: P0 = 0xCC; break;
    case 5: P0 = 0xA4; break;
    case 6: P0 = 0xA0; break;
    case 7: P0 = 0x8F; break;
    case 8: P0 = 0x80; break;
    case 9: P0 = 0x84; break;
  }
}

void output_rpm_number(unsigned int num) {
  char scan_pos, d_pos[4], pval;
  P2 = 0;
  d_pos[0] = 0;
  d_pos[1] = 0;
  d_pos[2] = 0;
  d_pos[3] = 0;
  num *= 60;
  if(num>=1000) {
    d_pos[0] = num/1000;
    num = num%1000;
  }
  if(num>=100) {
    d_pos[1] = num/100;
    num = num%100;
  }
  if(num>=10) {
    d_pos[2] = num/10;
    num = num%10;
  }
  d_pos[3] = num;
  pval = 1;
  for(scan_pos = 0;scan_pos < 4;scan_pos++) {
    P2 = 0;
    Delay_us(50);
    output_digit(d_pos[scan_pos]);
    P2 = pval;
    pval *= 2;
    Delay_us(100);
  }
  P2 = 0;
}

void external_isr() org 0x0003 ilevel 0 {
  count_pos++;
}

void timer0_isr() org 0x000B ilevel 1 {
  EA = 0;
  TR0 = 0;
  TH0 = 0x0FC;
  TL0 = 0x18;
  tk_counter++;
   if(tk_counter==1000) {
    tk_counter = 0;
    rpm_ = count_pos;
    count_pos = 0;
  }
  EA = 1;
  TR0 = 1;
}

void main() {
  tk_counter = 0;
  rpm_ = 0;
  EA = 0;
  IT0 = 1;
  EX0 = 1;
  TF0 = 0;
  ET0 = 1;
  EA = 1;
  TMOD.T0_GATE = 0;
  TMOD.T0_CT = 0;
  TMOD.T0_M0 = 1;
  TMOD.T0_M1 = 0;
  TR0 = 0;
  TH0 = 0x0FC;
  TL0 = 0x18;
  TR0 = 1;
  count_pos = 0;
  while(1==1)
    output_rpm_number(rpm_);
}
